﻿RpmAndAttacherEvent = {};
RpmAndAttacherEvent_mt = Class(RpmAndAttacherEvent, Event);

InitEventClass(RpmAndAttacherEvent, "RpmAndAttacherEvent");

function RpmAndAttacherEvent:emptyNew()
    local self = Event:new(RpmAndAttacherEvent_mt);
    self.className = "RpmAndAttacherEvent";
    return self;
end;

function RpmAndAttacherEvent:new(object, moreRpm, realAttacher)
    local self = RpmAndAttacherEvent:emptyNew()
    self.object = object;
	self.moreRpm = moreRpm;
	self.realAttacher = realAttacher;
    return self;
end;

function RpmAndAttacherEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
	self.moreRpm  = streamReadBool(streamId);
	self.realAttacher  = streamReadBool(streamId);
    self:run(connection);
end;

function RpmAndAttacherEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.moreRpm);
    streamWriteBool(streamId, self.realAttacher);
end;

function RpmAndAttacherEvent:run(connection)
  self.object:rpmAndAttacher(self.moreRpm, self.realAttacher, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(RpmAndAttacherEvent:new(self.object, self.moreRpm, self.realAttacher), nil, connection, self.object);
	end;
end;

function RpmAndAttacherEvent.sendEvent(object, moreRpm, realAttacher, noEventSend)
  if noEventSend == nil or noEventSend == false then
    if g_server ~= nil then
      g_server:broadcastEvent(RpmAndAttacherEvent:new(object, moreRpm, realAttacher), nil, nil, object);
    else
      g_client:getServerConnection():sendEvent(RpmAndAttacherEvent:new(object, moreRpm, realAttacher));
    end;
  end;
end;

